/* Copyright (c) 2006
   Colin Dewey (University of California, Berkeley)
   cdewey@eecs.berkeley.edu
   
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef __DISTANCE_CALCULATOR_HH__
#define __DISTANCE_CALCULATOR_HH__

#include "bio/newick.hh"
#include "bio/phylogenetic.hh"
#include "util/matrix.hh"

class DistanceCalculator {
public:
	DistanceCalculator(std::istream& strm);
	util::Matrix<double> getDistances();
	bio::Phylogenetic::Tree* getTree();
private:
	void readTree(std::istream& strm);
	static std::string spacesToUnderscores(const std::string& s);

	bio::Phylogenetic::Tree* tree;
};

#endif // __DISTANCE_CALCULATOR_HH__
