#include "math/LogDouble.hh"
#include "bio/alphabet/Alphabet.hh"

class LikelihoodCalculator {
public:
	typedef math::LogDouble Prob;
	
	LikelihoodCalculator(const bio::alphabet::Alphabet& alphabet,
						 Prob mu = 0, Prob delta = 0, Prob epsilon = 0);

	void setParams(Prob mu, Prob delta, Prob epsilon);
	
	Prob getLikelihood(const std::string& s1,
							const std::string& s2);
	
private:
	const bio::alphabet::Alphabet& alphabet;
	Prob mu;
	Prob delta;
	Prob epsilon;
};
